#Data from XML Schema xs:annotation declaration for elements
class Annotations:    
    def __init__(self, annotations):
        self.appinfo = None
        self.docinfo = None
        
        if annotations != None and len(annotations) > 0 and annotations[0] != None:
          try:
            self.appinfo = annotations[0].appinfo
          except:
            self.appinfo = None
          try:
            self.docinfo = annotations[0].documentation
          except:
            self.docinfo = None

    #Gets the tags not relevant to indexing for a document in a xml document based on xml schema
    def getRemoveTags(self):
        if self.appinfo == None or len(self.appinfo) == 0:
            return [None]  
        for child in self.appinfo[0].children:
	    try:
                if child.localName == "remove":
                    content = "%s" % child.children[0].characters
                    return content.split(" ")
            except Exception,e:
            	pass
        return [None]
    
    #Gets the datatype for an element in a xml document based on xml schema
    def getDataType(self):
        if self.appinfo == None or len(self.appinfo) == 0:
            return None
        for child in self.appinfo[0].children:
            if child.localName == "datatype":
                content = "%s" % child.children[0].characters
                return content
        return None

    #Gets the format for an element in a xml document based on xml schema
    def getFormat(self):
        if self.appinfo == None or len(self.appinfo) == 0:
            return None
        for child in self.appinfo[0].children:
            try:
                if child.localName == "format":
                    content = "%s" % child.children[0].characters
                    return content
            except Exception,e:
            	pass
        return None
        
    #Gets which items to concenate for mixed content items in a xml document based on xml schema
    def getMixedConcenate(self):
        if self.appinfo == None or len(self.appinfo) == 0:
            return None
        for child in self.appinfo[0].children:
            try:
                if child.localName == "concenate":
                    content = "%s" % child.children[0].characters
                    content = (content != "" and content.split("|") or None)
                    return content
            except Exception,e:
            	pass
        return None
        