import os, string, sys, cStringIO, glob

from bsddb.db import *
from dbxml import *
from Ft.Xml.Domlette import NonvalidatingReader, Print
from Ft.Xml.Xslt import Processor

class BerkeleyDBXML:
    def __init__(self):     
        self.Output = None
        
    #Delete current Berkeley DB XML database
    def remove_database(self, name):
        self.Output("Berkeley DBXML", "Deleting existing Berkeley DBXML files.")
        databases = [name]
        for database in databases:
            files = glob.glob(database + "*.dbxml")
            files += glob.glob("__db*")
            files += glob.glob("log.*")
            for file in files:
                os.remove(file)

    #Walk directory for XML files and add them to database
    def xml_walk(self, (mgr, container,uc), dirr, filess):  
        for child in filess:
            if dirr.find("inex") > -1 and string.find(child, "article_") == -1: #skipping some inex files
                pass
            elif string.find(child.lower(), ".xml") > -1: #import to Berkeley DB XML if ending with .xml
                dirr = string.replace(dirr, "\\", "/")
                file = mgr.createLocalFileInputStream(dirr+'/'+child)
                child = dirr+'/' + child
                child = string.replace(child, "/", "") #Berkeley DB XML document ID
                container.putDocument(child, file, uc, 0)
                self.Output("Berkeley DBXML", "Adding: " + child)
                
    def addXML(self, bdxmlpath, path): #Remove current DB and create new, start walking path
        self.remove_database(bdxmlpath) #remove current db 
        self.Output("Berkeley DBXML", "Creating new Berkeley DBXML database.")
        mgr = XmlManager(DBXML_ALLOW_EXTERNAL_ACCESS) #allow accessing external resources
        mgr.setInitializeCache = True
        uc = mgr.createUpdateContext()
        container = mgr.createContainer(bdxmlpath + ".dbxml") #create db
        container.setAllowValidation = True #allow validation of XML Schema
        self.Output("Berkeley DBXML", "Adding XML files in path: %s." % path)
        os.path.walk(path, self.xml_walk, (mgr, container, uc))
        container.close()

    def run(self,bdxmlpath, Output, path): #start importing files in path to Berkeley DB XML
        self.Output = Output
        print "\n-Adding XML files to Berkeley DBXML."
        self.Output("Berkeley DBXML", "Script started.")
        self.addXML(bdxmlpath, path)
        self.Output("Berkeley DBXML", "Script finished.")
        print "-Finished adding to DBXML."