import time
import re

#Normlize data based on datatype and xs:annotation information before indexing using PyLucene
#Each datatype removes not wanted data or transforms into a given format like date.
class DataType:
    def __init__(self):
        pass
    
    def Modify(self, text, datatype, format): #normalize text based on content and/or the format
        if datatype == "year": #Only keep numbers for year
            text = re.sub("[\D]", "", text)
        elif datatype == "date" and format:  #Format year if format is given in xs:annotation.
       	    try:
                ctime = time.strptime(text, format)
                text = "%s%s%s" % (ctime[0], (ctime[1] < 10 and "0%s" % ctime[1] or ctime[1]), (ctime[2] < 10 and "0%s" % ctime[2] or ctime[2]))
            except Exception,e:
            	return text
        elif datatype == "string": #if string, do nothing
            pass
        elif datatype == "phrase": #if phrase, remove anything not alphanumeric
            text = re.sub("[\W]", "", text)
        elif datatype == "identifier": #if identifier, keep everything
            pass
        elif datatype == "numeric": #if numeric, remove anything not numeric
            text = re.sub("[\D]", "", text)
        elif datatype == "numericstring": #if numericstring, remove nothing
            pass
        elif datatype == "urx": #only accept urx if it contains https
            if text.lower().find("http://") == -1:
                text = ""
        elif datatype == "word": #if word, keep only characters
            text = re.sub("[\W]", "", text)
        return text