import exceptions, os, imp, sre, sys, cStringIO, gc, zlib, marshal, psyco, cPickle
import cgi,time, urllib, PyLucene, copy, math
import cElementTree as ElementTree

import Modules.Database as Database
import Modules.Lucene.Streams as Streams
import Modules.Lucene.CustomQueryParser as CustomQueryParser
import Modules.DataTypeNormalizer as DataType

from threading import Thread, Event, RLock
from os import curdir, sep
from PyLucene import QueryParser, VERSION, LUCENE_VERSION, Highlighter, QueryScorer, wrapAnalyzer
from CommonFunctions import *

class HTTPProcessor:
    def __init__(self, host, port):
        self.datatype = DataType.DataType()
        self.database = Database.Database()
        self.host = host
        self.port = port
        (self.bdxmlpath, self.analyzer, self.container, self.manager, self.searcher, self.reader, self.pathindexDB, self.docsFileName, self.docsStore, self.qc, self.datatypeDB) = self.database.OpenSearch()
        print "-Indexes accessed"
        
    def Close(self):
        self.database.CloseSearch()

    #browse a document (only up the tree currently implemented        
    def browse(self, argdict):
        try:
            html = ""
            input = argdict["query1"]
            input = urllib.unquote_plus(input)
            if argdict.get("file", "") == "":
                argdict["file"] = "collection"
            file = argdict["file"]
            counter = 0
            if input: 
                html += """<BR><a href="%s">%s</a><BR>""" % ("http://%s:%s/xquery?query1=/*&file=%s&action=Browse" % (self.host, self.port, file), file)
                html += self.createBrowsePath(input, file)
                html += "<BR>"
                input = input.replace("/", "/*:")
                if len(input) > 3 and input[-3:] == "*:*":
                    input = input[:-2]
                input = input.replace("*:@", "@")
                
                if file == "collection":
                    results = self.manager.query("collection('" + self.bdxmlpath + "')%s" % input, self.qc)
                else:
                    results = self.manager.query('doc("' + self.bdxmlpath + "/" + file + '")' + input, self.qc)
                results.reset()    
                for value in results:
                    document = value.asDocument()
                    data = value.asString()
                    data = data.replace("<", "&lt;")
                    data = data.replace(">", "&gt;")
                    html +=  "<BR><pre>" + data + "</pre><BR>"
                    counter += 1
                    if counter == 100:
                        break
        except Exception,e:
            print "browse 1: %s" % e
            html = "browse 1: %s" % e
        return html

    def createBrowsePath(self, path, file=""): #create xpath URL
        html = ""
        xquery = ""
        splitted = []
        if not file:
            splitted = path[1].split("/")
            file = path[0]
        else:
            splitted = path.split("/")
        for split in splitted:
            if split != "*":
                xquery += split + "/"
                html += """<B><a href="%s">%s</a>/</B>""" % ("http://%s:%s/xquery?query1=%s&file=%s&action=Browse" % (self.host, self.port, xquery[:-1], file), split)
        html += """<B><a href="%s">%s</a>/</B>""" % ("http://%s:%s/xquery?query1=%s/*&file=%s&action=Browse" % (self.host, self.port, xquery[:-1], file), "*")
        return html

    def createSearch(self, argdict): #create PyLucene queries
        sort = PyLucene.Sort(PyLucene.SortField.FIELD_DOC)

        try:
            html = ""    
            where1 = ""
            queries = []
            results = []
            defField = (argdict.get("casesensitive", "off") == "on" and "content" or "contentL")
            if argdict.get("query1", ""):
                queries.append(["or", urllib.unquote_plus(argdict["query1"])])
            if argdict.get("query2", ""):
                queries.append([argdict["querytype2"], urllib.unquote_plus(argdict["query2"])])
            if argdict.get("query3", ""):
                queries.append([argdict["querytype3"], urllib.unquote_plus(argdict["query3"])])
            if argdict.get("where1", ""):
                where1 = [argdict["wheretype1"], urllib.unquote_plus(argdict["where1"]), ""]
            sTime = time.time()
            qParser = wrapAnalyzer(self.analyzer).queryParser(CustomQueryParser.CustomQueryParser(), defField) #use custom query parser
            if len(queries) > 0:        
                queryparser = []
                qt = ""
                for query in queries: #if advance
                    if not query[0] == "AND NOT" and query:
                        qt += query[1] + " " + query[0].upper() + " "  
                    qparser = qParser.parseQuery(query[1])
                    queryparser.append(qparser)  #parse queries
                qt = qt.strip()
                qt = qt[0:qt.rfind(" ")]
                scorer = QueryScorer(qParser.parseQuery(qt).rewrite(self.reader)) #create scorer

                hitsSet = [] 
                for qp in queryparser: #for each query, do search and add result to hitset
                    hitsSet.append((qparser, self.searcher.search(qp)))
                if len(queryparser) > 0 and where1:
                    if where1[1].find("path:") > -1:
                        where1[2] = where1[1][0:where1[1].find(" ")]
                        where1[2] = where1[2].replace("path:", "")  
                        qp = qParser.parseQuery(where1[1][where1[1].find(" "):])
                    else:
                        where1[2] = "/"
                    qp = QueryParser.parse(where1[1], defField, self.analyzer)
                    where1 = [where1[0], self.searcher.search(qp), where1[2]]

		#create searchresultpage
                (htmlTop, results) = self.doSearch(hitsSet, self.manager, self.qc, queries, argdict)
                html += self.createResultPage(results, htmlTop, Highlighter(scorer), defField)
        except Exception,e:
            print "search: %s" % e
            html = "search: %s" % e
        return (len(results), html)

    def doSearch(self, hitsSet, manager, qc, queries, argdict): #for each hitset, add results together into one result if it is a advance search (Based on boolean operators)
        docs = {}
        html = ""
        htmlTop = ""
        sTime = time.time()
        docs = {}
        for nr in xrange(len(hitsSet)): #for each searchresult
            hits = hitsSet[nr][1]
            querytype = queries[nr][0]
            docsAND = {}
            for hit in xrange(hits.length()):  #for each result in searchresult
                doc = hits.doc(hit)
                docID = int(doc.get("docID").encode('ascii')) + 1
                if querytype == "or": #which boolean type
                    docs[docID] = self.docsStore[docID]
                elif querytype == "and":
                    if not docs.has_key(docID):
                        continue
                    docsAND[docID] = 1
                elif querytype == "andnot":
                   if docs.has_key(docID):
                       del docs[docID]
                   continue
                tree = doc.get("treeLoc").split(" ") #treelocation, only used for advance search
                test = docs[docID]
                test.set("count", test.get("count", 0) + 1)
                for id in range(0, len(tree)):
                    treenode = int(tree[id])
                    test[treenode].set("count", test[treenode].get("count", 0) + 1)
                    test[treenode].set("score", 0)
                    test[treenode].set("pathID", int(doc.get("pathID")))
                    if id < len(tree) - 1:
                        test = test[treenode]
                    else:
                        test[treenode].set("score", test[treenode].get("score", 0) + math.pow( hits.score(hit), id + 1))
            if querytype == "and":
                for ID in docs.keys():
                    if not docsAND.has_key(ID):
                        del docs[ID]
        sTime = time.time()
        results = []
        for doc in docs.keys(): #walk tree for each result,
            doc_results = self.walk(doc, docs[doc])[0]
            if len(doc_results) > 0:
                if argdict["type"] == "advanced":
                    while len(doc_results) > 1:
                        doc_results[0][2] += doc_results[1][2]
                        del doc_results[1]
                    doc_results[0][1] = docs[doc].tag[1:]
                results += doc_results
        results.sort(lambda x, y: cmp(y[2], x[2]))
        return (htmlTop, results)

    def walk(self, doc, tree): #does nothing, can be used for adding multiple results in the document tree together
        sum = 0
        count = 0
        results = []   
        for treenode in tree:
            tCount = treenode.get("count", 0)
            if tCount!= 0:
                tScore = treenode.get("score")
                sum += tScore
                count += 1
                if tScore > 0:
                    results.append([doc, int(treenode.get("pathID")), tScore]) 
                if len(treenode) > 0:
                    (uptreeres, uptreescore, counter) = self.walk(doc, treenode)
                    results += uptreeres
                    treenode.set("score", 0)
                treenode.set("count", 0)
        return (results, sum, count)
        
    def createResultPage(self, results, htmlTop, highlighter, defField): #retrieves fulltext from berkeley db xml and creates result page
        sTime = time.time()               
        counter = 0
        html = """<br>"""
        for (docID, pathID, score) in results:
            docID = self.docsFileName[docID - 1]
            counter += 1
            path = deserialize_via_marshal(self.pathindexDB.get(int(pathID)))  #get xpath
            html += """<BR><B>%s. <a href="%s">%s</a> - (%s)</B>""" % (counter, "http://%s:%s/xquery?query1=/*&file=%s&action=Browse" % (self.host, self.port, docID), docID, score)
            html += "<BR>" + self.createBrowsePath(path, docID) + "<BR>"
            if path.find("@") != -1:
                path = path[0:path.find("@") + 1] + "*"
            query = str('doc("' + self.bdxmlpath + "/" + docID + '")' + path.replace("/", "/*:").replace("*:@", "@"))
            results = self.manager.query(query, self.qc)
            results.reset()    
            
            for value in results: #for each result, get fulltext
                htmldata = sre_html.sub(' ', value.asString())
                if htmldata != "<BR>":
                    html += htmldata
                else:
                    html += value.asString() + "<BR>"
            if counter == 100:
                break
        return htmlTop + html