import datetime, os


class Logger:
    def __init__(self):
        self.log = []
        self.verbose = False
        
    #Clears screen, both Unix and Windows
    def clearScreen(self):
        a=os.name
        if a=='posix':
            os.system('clear')
        elif a=='nt':
            os.system('cls')  
            
    #adds new line to log
    def addToLog(self, caller, text):
        self.log.append([str(datetime.datetime.now())[:-7], caller, text])
        
    #outputs a new logitem to screen
    def Output(self, caller, text):
        self.addToLog(caller,text)
        if self.verbose:
            print "- %s, %s : %s" % (str(datetime.datetime.now())[:-7], caller,text)
        
    #prints log to screen
    def showLog(self):
        print "--- Start of log ---"
        for datemark, caller, text in self.log:
            print " -%s, %s : %s" % (datemark, caller,text)
        print "--- End of log ---"
        
    #toggle verbose log to screen on/off
    def toggleVerbose(self):
        if self.verbose:
            print "-Verbose disabled"
            self.verbose = False
        else:
            print "-Verbose enabled"
            self.verbose = True