from PyLucene import PhraseQuery, RangeQuery, SpanNearQuery, SpanTermQuery, Term
from NumberUtils import NumberUtils

#Supports adding functionality for finding similar matches to a query
class CustomQueryParser(object):

    def getRangeQuery(self, super, field, part1, part2, inclusive):
        inclusive = True
        if field == "numeric" or field == "year": #if numeric or year datatype, use rangequery for finding similar matches
            num1 = int(part1)
            num2 = int(part2)
            return RangeQuery(Term(field, NumberUtils.pad(num1)),
                              Term(field, NumberUtils.pad(num2)),
                              inclusive)

        return super.getRangeQuery(field, part1, part2, inclusive)

    def getFieldQuery(self, super, field, queryText, slop):
        if field == "phrase": #use fuzzy search if a phrase
            queryText += "~"
        elif field == "numeric":
            return self.getRangeQuery(super, field, int(queryText) * 0.9, int(queryText) + int(queryText) * 1.1, True)
        elif field == "year":
            return self.getRangeQuery(super, field, int(queryText) - 10, int(queryText) + 10, True)
        return super.getFieldQuery(field, queryText) 