from PyLucene import *
from numberFilter import *
from dateFilter import *
from yearFilter import *

#For each defined datatype a distinct filter can be used to select the terms to use for indexing in PyLucene
class myAnalyzer(object):    
    def __init__(self):
        pass
    def tokenStream(self, fieldName, reader):
        tokenStream = StandardFilter(StandardTokenizer(reader)) 
        if fieldName == "contentL":
            tokenStream = LowerCaseFilter(tokenStream)   
        elif fieldName == "phrase":
            tokenStream = LowerCaseFilter(tokenStream)   
            tokenStream = StopFilter(tokenStream, StopAnalyzer.ENGLISH_STOP_WORDS)
            tokenStream = PorterStemFilter(tokenStream)
        elif fieldName == "word":
            tokenStream = LowerCaseFilter(tokenStream)   
        elif fieldName == "year":
            tokenStream = yearFilter(tokenStream) 
        elif fieldName == "date":
            tokenStream = dateFilter(tokenStream) 
        elif fieldName == "name":
            tokenStream = LowerCaseFilter(tokenStream)   
        elif fieldName == "urx":
            pass
        elif fieldName == "numericstring":
            pass
        elif fieldName == "numeric":
            tokenStream = numberFilter(tokenStream)
        elif fieldName == "string":
             tokenStream = LowerCaseFilter(tokenStream)   
        return tokenStream